#include <allegro.h>
#include <fstream>
#include <iostream>
#include <string>
#include "Imagens.h"
#include "GrupoDeImagem.h"
#include "ConstantesDeDados.h"

using namespace std;

Imagens::Imagens(char *nomeDoArquivo, char *enderecoDoCenario) {
    this->cenario = load_bitmap(enderecoDoCenario, NULL);
    ifstream arquivo(nomeDoArquivo, ios::in);
    int totalDeMovimentos;
    arquivo >> totalDeMovimentos;


    GrupoDeImagem **arr;
    arr = new GrupoDeImagem*[totalDeMovimentos];

    int posicaoVaga = 0;
    int contador = 0;
    BITMAP *imagem;
    while (contador != totalDeMovimentos) {
        char enderecoDaImagem[50];
        int numeroDeAcoes;
        int coordX = 0;
        int coordY = 0;

        //Lendo o Arquivo
        arquivo >> enderecoDaImagem;
        arquivo >> numeroDeAcoes;

        //Carregando a Imagem
        imagem = load_bitmap(enderecoDaImagem, NULL);
        int numeroDeEventosDaAcao;
        int width, height;
        for (int i = 0; i < numeroDeAcoes; i++) {
            coordX = 0;
            string comentarioDesprezivel;

            arquivo >> comentarioDesprezivel;
            arquivo >> numeroDeEventosDaAcao;
            arquivo >> width >> height;

            GrupoDeImagem *sequenciaDeFiguras = new GrupoDeImagem(numeroDeEventosDaAcao);

            for (int j = 0; j < numeroDeEventosDaAcao; j++) {
                sequenciaDeFiguras->array[j] = create_sub_bitmap(imagem, coordX, coordY, width, height);
                coordX = coordX + width;
            }
            arr[posicaoVaga] = sequenciaDeFiguras;
            posicaoVaga = posicaoVaga + 1;
            coordY = coordY + height;
        }
        contador = contador + numeroDeAcoes;
    }
    this->array = arr;
}

Imagens::~Imagens() {
    destroy_bitmap(cenario);
    delete[] array;
}

GrupoDeImagem *Imagens::pegarSequenciaDeImagensDe(int nome) {
    return this->array[nome];
}


BITMAP *Imagens::getCenario() {
    return this->cenario;
}

void Imagens::setCenario(char *endereco) {
    this->cenario = load_bitmap(endereco, NULL);
}
