#include "allegro.h"
#include <stdio.h>
#include "Servidor/ConstantesDeConfiguracao.h"
#include "Servidor/ConstantesDeDados.h"
#include "Servidor/Controle.h"
#include "GrupoDeImagem.h"
#include "Saida.h"
#include "Servidor/Personagem.h"
#include "Servidor/Inimigo.h"
#include "Imagens.h"
#include "Servidor/servidor.h"


//Saida::Saida(Controle *controle, Imagens *imagens) {
Saida::Saida(Imagens* imagens){
	this->imagensDaFase = imagens;
    this->cenario = imagens->getCenario();
    this->buffer = create_bitmap(MAX_X, MAX_Y);


    //(Nessa nova implementao : os atributos de controle e imagem provem da struct passada pelo servidor
	//this->controleDaFase = controle;
    
}

Saida::~Saida() {
    //delete(controleDaFase);
    //delete(imagensDaFase);
    destroy_bitmap(buffer);
    //destroy_bitmap(cenario);

}

void Saida::imprimirNaTela(int respostaControle,BITMAP* bufferPause, BITMAP* imagemPause) {
    if (respostaControle != PAUSADO && respostaControle != SAIR) {
		draw_sprite(this->buffer, this->cenario, this->retornoServidor->coordenadaCenario, 0);

        this->imprimirJogadorLuigi(LUIGI_ANDANDO, LUIGI_ESPECIAL_ANDANDO);
		if (!this->retornoServidor->umJogador) {
            this->imprimirJogadorMario(MARIO_ANDANDO, MARIO_ESPECIAL_ANDANDO);
        }
        this->imprimirInimigos();
        /*char ae[40];
        sprintf(ae,"%d",controleDaFase->tempoMario);
        textout(screen,font,ae,10,100,makecol(255,0,0));
        _sleep(100);*/
        draw_sprite(screen, this->buffer, 0, 0);
        rest(15);
    } else if (respostaControle == SAIR) {

    } else {
        draw_sprite(bufferPause, imagemPause, 0, 0);
        draw_sprite(screen, bufferPause, (MAX_X - imagemPause->w)/2, (MAX_Y - imagemPause->h)/2);
        clear_bitmap(bufferPause);
    }
}

void Saida::imprimirSprite(int x, int y, int spriteASerImpresso, int indiceDaAcao) {
    GrupoDeImagem *imagem = this->imagensDaFase->pegarSequenciaDeImagensDe(spriteASerImpresso);
    int tamanho = imagem->getTamanho();
    int indice = indiceDaAcao % tamanho;
    int coordX = x;
    int coordY = y;
    BITMAP *img = imagem->array[indice];
    draw_sprite(this->buffer, img, coordX, coordY);
}

void Saida::imprimirSpriteParaEsquerda(int x, int y, int spriteASerImpresso, int indiceDaAcao) {
    GrupoDeImagem *imagem = this->imagensDaFase->pegarSequenciaDeImagensDe(spriteASerImpresso);
    int tamanho = imagem->getTamanho();
    int indice = indiceDaAcao % tamanho;
    int coordX = x;
    int coordY = y;
    BITMAP *img = imagem->array[indice];
    rotate_sprite_v_flip(this->buffer, img, x, y, itofix(128));
}

void Saida::imprimirJogadorLuigi(int spriteNormal, int spriteEspecial) {
    if (retornoServidor->vivoLuigi) {
        int x = retornoServidor->xLuigi;
        int y = retornoServidor->yLuigi;
        int estadoX = retornoServidor->estadoXLuigi;
        int estadoY = retornoServidor->estadoYLuigi;
        int status = retornoServidor->statusLuigi;
        int sprite;

        if (status == NORMAL) {
            sprite = spriteNormal;
        } else {
            sprite = spriteEspecial;
        }

        if (estadoX == PARADO) {
            if (retornoServidor->viradoFrenteLuigi) {
                this->imprimirSprite(x, y, sprite, 0);
            } else {
                this->imprimirSpriteParaEsquerda(x, y, sprite, 0);
            }
        } else if (estadoX == ANDANDO) {
            int indice = retornoServidor->indiceAndandoLuigi;
            if (retornoServidor->viradoFrenteLuigi) {
                this->imprimirSprite(x, y, sprite, indice);
            } else {
                this->imprimirSpriteParaEsquerda(x, y, sprite, indice);
            }
        } else if (estadoY == PULANDO) {
            int indice = retornoServidor->indiceAndandoLuigi;
            if (retornoServidor->viradoFrenteLuigi) {
                this->imprimirSprite(x, y, sprite, indice);
            } else {
                this->imprimirSpriteParaEsquerda(x, y, sprite, indice);
            }
        } else if (estadoY == CAINDO) {
            int indice = retornoServidor->indiceAndandoLuigi;
            if (retornoServidor->viradoFrenteLuigi) {
                this->imprimirSprite(x, y, sprite, indice);
            } else {
                this->imprimirSpriteParaEsquerda(x, y, sprite, indice);
            }
        }  else {

        }
    } else {

    }
}

void Saida::imprimirJogadorMario(int spriteNormal, int spriteEspecial) {
    if (this->retornoServidor->vivoMario) {
        int x = this->retornoServidor->xMario;
        int y = this->retornoServidor->yMario;
        int estadoX = this->retornoServidor->estadoXMario;
        int estadoY = this->retornoServidor->estadoXMario;
        int status = this->retornoServidor->statusMario;
        int sprite;

        if (status == NORMAL) {
            sprite = spriteNormal;
        } else {
            sprite = spriteEspecial;
        }

        if (estadoX == PARADO) {
            if (this->retornoServidor->viradoFrenteMario) {
                this->imprimirSprite(x, y, sprite, 0);
            } else {
                this->imprimirSpriteParaEsquerda(x, y, sprite, 0);
            }
        } else if (estadoX == ANDANDO) {
            int indice = this->retornoServidor->indiceAndandoMario;
            if (this->retornoServidor->viradoFrenteMario) {
                this->imprimirSprite(x, y, sprite, indice);
            } else {
                this->imprimirSpriteParaEsquerda(x, y, sprite, indice);
            }
        } else if (estadoY == PULANDO) {
            int indice = this->retornoServidor->indiceAndandoMario;
            if (this->retornoServidor->viradoFrenteMario) {
                this->imprimirSprite(x, y, sprite, indice);
            } else {
                this->imprimirSpriteParaEsquerda(x, y, sprite, indice);
            }
        } else if (estadoY == CAINDO) {
            int indice = this->retornoServidor->indiceAndandoMario;
            if (this->retornoServidor->viradoFrenteMario) {
                this->imprimirSprite(x, y, sprite, indice);
            } else {
                this->imprimirSpriteParaEsquerda(x, y, sprite, indice);
            }
        }  else {

        }
    } else {

    }
}


void Saida::imprimirInimigos() {
    int numeroInimigos = this->retornoServidor->quantidadeInimigos;
    for (int i = 0; i < numeroInimigos; i++) {

        if (this->retornoServidor->inimigoVivo[i]) {
			if (this->retornoServidor->inimigoViradoFrente[i]) {
				this->imprimirSprite(this->retornoServidor->xInimigo[i], this->retornoServidor->yInimigo[i], INIMIGO_TIPO_1, this->retornoServidor->inimigoIndiceAndando[i]);
            } else {
                this->imprimirSpriteParaEsquerda(this->retornoServidor->xInimigo[i], this->retornoServidor->yInimigo[i], INIMIGO_TIPO_1, this->retornoServidor->inimigoIndiceAndando[i]);
            }
        }

    }
}



void Saida::setEstagio(Imagens *imagens) {
    this->imagensDaFase = imagens;
    this->cenario = imagens->getCenario();
}
void Saida::setServidor(servidor* ehNois){
	this->retornoServidor = ehNois;
}



