#include <allegro.h>

#include "ColisaoDinamica.h"
#include "Personagem.h"
#include "ConstantesDeConfiguracao.h"
#include <iostream>

ColisaoDinamica::ColisaoDinamica(Personagem** ini,int tam) {

    this->inimigos = ini;
    this->qntInimigos = tam;
    retorno = new ObjetoRetornoColisao(NULL,0);


}

ObjetoRetornoColisao* ColisaoDinamica::getRetornoColisao() {
    return this->retorno;
}

int ColisaoDinamica::verificarColisaoDireitaEmInimigos(Personagem* p1, int proxPosicao) {

    int retorno = 0;
    if (p1->getVivo()) {
        int tipo = 0;
        int index = 0;
        while (tipo == 0 && index < this->qntInimigos ) {
            if (this->inimigos[index]->getVivo()) {
                retorno = this->colisaoDireita(p1,this->inimigos[index]);
                if (retorno == 1) tipo = 1;
                else if (retorno == 2) tipo = 2;
            }
            index++;
        }
        this->retorno->setTipoDeColisao(tipo);
        this->retorno->setInimigo(this->inimigos[index-1]);
    }
    return retorno;


}

int ColisaoDinamica::verificarColisaoEsquerdaEmInimigos(Personagem* p1, int proxPosicao) {

    int retorno = 0;
    if (p1->getVivo()) {
        int tipo = 0;
        int index = 0;
        while (tipo == 0 && index < this->qntInimigos ) {
            if (this->inimigos[index]->getVivo()) {
                retorno = this->colisaoEsquerda(p1,this->inimigos[index]);
                if (retorno == 1) tipo = 1;
                else if (retorno == 2) tipo = 2;
            }
            index++;
        }
        this->retorno->setTipoDeColisao(tipo);
        this->retorno->setInimigo(this->inimigos[index-1]);
    }
    return retorno;


}

int ColisaoDinamica::verificarColisaoCimaEmInimigos(Personagem* p1, int proxPosicao) {


    int retorno = 0;
    if (p1->getVivo()) {
        int tipo = 0;
        int index = 0;
        while (tipo == 0 && index < this->qntInimigos ) {
            if (this->inimigos[index]->getVivo()) {
                retorno = this->colisaoCaindo(p1,this->inimigos[index], proxPosicao);
                if (retorno == 1) tipo = 1;
                else if (retorno == 2) tipo = 2;
            }
            index++;
        }
        this->retorno->setTipoDeColisao(tipo);
        this->retorno->setInimigo(this->inimigos[index-1]);
    }
    return retorno;

}




int ColisaoDinamica::colisaoDireita(Personagem* caixa1, Personagem* caixa2) {


    int caixa1CoordX = caixa1->getPosicaoX() + 3;
    int caixa1CoordY = caixa1->getPosicaoY();
    int caixa1TamanhoX = caixa1->getTamanhoX() - 3;
    int caixa1TamanhoY = caixa1->getTamanhoY();

    int caixa2CoordX = caixa2->getPosicaoX() + 3;
    int caixa2CoordY = caixa2->getPosicaoY();
    int caixa2TamanhoX = caixa2->getTamanhoX() - 3;
    int caixa2TamanhoY = caixa2->getTamanhoY();

    int maiorAltura;
    Personagem* caixaMaior;
    Personagem* caixaMenor;

    if ( caixa2TamanhoY > caixa1TamanhoY ) {

        caixaMaior = caixa2;
        caixaMenor = caixa1;

    } else {

        caixaMaior = caixa1;
        caixaMenor = caixa2;

    }

    if ( caixa1CoordY < caixa2CoordY ) {

        maiorAltura = caixa1TamanhoY;

    } else {

        maiorAltura = caixa2TamanhoY;

    }

    int caixa1VelocidadeDireita = 0;
    int caixa2VelocidadeDireita = 0;


    if (caixa1->getEstadoX() != PARADO  ) {
        caixa1VelocidadeDireita = caixa1->getVelocidade();
    }


    if (caixa2->getViradoPraFrente()) {

        caixa2VelocidadeDireita = caixa2->getVelocidade();

    } else {

        caixa2VelocidadeDireita = -(caixa2->getVelocidade());
    }



    if (caixa1CoordX <= caixa2CoordX) {

        if (((caixa2CoordX + caixa2VelocidadeDireita) - (caixa1CoordX + caixa1VelocidadeDireita) )<= caixa1TamanhoX - 4) {

            if ( abs(caixa1CoordY - caixa2CoordY) <= maiorAltura) {


                if ( (caixaMaior->getPosicaoY() + caixaMaior->getTamanhoY()) > (caixaMenor->getPosicaoY() + 8) ) {

                    return 1; //Lado morre!
                } else {

                    return 3; //Mata bixo
                }


            } else {

                return 3; //No houve colisao!

            }

        } else {

            return 3;

        }



    } else {

        if ((caixa1CoordX + caixa1VelocidadeDireita) - (caixa2CoordX + caixa2VelocidadeDireita) <= caixa2TamanhoX - 4) {


            if ( abs(caixa1CoordY - caixa2CoordY) <= maiorAltura) {


                if ( caixaMaior->getPosicaoY() + caixaMaior->getTamanhoY() > caixaMenor->getPosicaoY() + 8) {

                    return 1;
                } else {

                    return 3;
                }


            } else {

                return 3;

            }


        } else {

            return 3;

        }

    }

    return 3;


}

int ColisaoDinamica::colisaoEsquerda (Personagem* caixa1, Personagem* caixa2) {


    int caixa1CoordX = caixa1->getPosicaoX();
    int caixa1CoordY = caixa1->getPosicaoY();
    int caixa1TamanhoX = caixa1->getTamanhoX();
    int caixa1TamanhoY = caixa1->getTamanhoY();

    int caixa2CoordX = caixa2->getPosicaoX();
    int caixa2CoordY = caixa2->getPosicaoY();
    int caixa2TamanhoX = caixa2->getTamanhoX();
    int caixa2TamanhoY = caixa2->getTamanhoY();

    int maiorAltura;
    Personagem* caixaMaior;
    Personagem* caixaMenor;

    if ( caixa2TamanhoY > caixa1TamanhoY ) {

        caixaMaior = caixa2;
        caixaMenor = caixa1;

    } else {

        caixaMaior = caixa1;
        caixaMenor = caixa2;

    }

    if ( caixa1CoordY < caixa2CoordY ) {

        maiorAltura = caixa1TamanhoY;

    } else {

        maiorAltura = caixa2TamanhoY;

    }

    int caixa1VelocidadeDireita = 0;
    int caixa2VelocidadeDireita = 0;


    if (caixa1->getEstadoX() != PARADO) {
        caixa1VelocidadeDireita = -(caixa1->getVelocidade());
    }


    if (caixa2->getViradoPraFrente()) {

        caixa2VelocidadeDireita = caixa2->getVelocidade();

    } else {

        caixa2VelocidadeDireita = -(caixa2->getVelocidade());
    }


    if (caixa1CoordX <= caixa2CoordX) {

        if ((caixa2CoordX + caixa2VelocidadeDireita - caixa1CoordX + caixa1VelocidadeDireita ) <= caixa1TamanhoX - 4) {

            if ( abs(caixa1CoordY - caixa2CoordY) <= maiorAltura) {


                if ( (caixaMaior->getPosicaoY() + caixaMaior->getTamanhoY()) > (caixaMenor->getPosicaoY() + 8) ) {

                    return 1;
                } else {

                    return 3;
                }


            } else {

                return 3;

            }

        } else {

            return 3;

        }



    } else {

        if (((caixa1CoordX + caixa1VelocidadeDireita) - (caixa2CoordX + caixa2VelocidadeDireita)) <= caixa2TamanhoX - 4) {


            if ( abs(caixa1CoordY - caixa2CoordY) <= maiorAltura) {


                if ( caixaMaior->getPosicaoY() + caixaMaior->getTamanhoY() > caixaMenor->getPosicaoY() + 8) {

                    return 1;
                } else {

                    return 3;
                }



            } else {

                return 3;

            }


        } else {

            return 3;

        }

    }




}

int ColisaoDinamica::colisaoCaindo(Personagem* caixa1, Personagem* caixa2, int proxPosicao) {



    int caixa1CoordX = caixa1->getPosicaoX();
    int caixa1CoordY = caixa1->getPosicaoY();
    int caixa1TamanhoX = caixa1->getTamanhoX();
    int caixa1TamanhoY = caixa1->getTamanhoY();

    int caixa2CoordX = caixa2->getPosicaoX();
    int caixa2CoordY = caixa2->getPosicaoY();
    int caixa2TamanhoX = caixa2->getTamanhoX();
    int caixa2TamanhoY = caixa2->getTamanhoY();

    int maiorAltura;
    Personagem* caixaMaior;
    Personagem* caixaMenor;

    if ( caixa2TamanhoY > caixa1TamanhoY ) {

        caixaMaior = caixa2;
        caixaMenor = caixa1;

    } else {

        caixaMaior = caixa1;
        caixaMenor = caixa2;

    }

    if ( caixa1CoordY < caixa2CoordY ) {

        maiorAltura = caixa1TamanhoY;

    } else {

        maiorAltura = caixa2TamanhoY;

    }



    if (caixa1CoordX <= caixa2CoordX) {

        if ((caixa2CoordX - caixa1CoordX )<= caixa1TamanhoX-2) {



            if ( abs((caixa1CoordY) - caixa2CoordY) <= caixa1TamanhoY + 3) {


                if ( (caixaMaior->getPosicaoY() + caixaMaior->getTamanhoY()) > (caixaMenor->getPosicaoY()+ 12 ) ) {

                    return 1;
                } else {

                    return 2;

                }


            } else {

                return 3;

            }

        } else {

            return 3;

        }



    } else {

        if (caixa1CoordX - caixa2CoordX <= caixa2TamanhoX - 2) {


            if ( abs((caixa1CoordY ) - caixa2CoordY) <= maiorAltura + 3) {


                if ( caixaMaior->getPosicaoY() + caixaMaior->getTamanhoY() > caixaMenor->getPosicaoY() + 12) {

                    return 1;

                } else {

                    return 2;

                }



            } else {

                return 3;

            }


        } else {

            return 3;

        }

    }

}

ColisaoDinamica::~ColisaoDinamica() {
    delete(retorno);
}
