#include "ColisaoEstatica.h"

ColisaoEstatica::ColisaoEstatica(BITMAP* mapa){
    this->mapaDeColisao = mapa;
    this->acabouEstagio = false;
    this->retorno = new RetornoEstatica();
}

ColisaoEstatica::~ColisaoEstatica(){
    delete(this->retorno);
}

void ColisaoEstatica::caindo(Personagem* p1,int cenario){
    int valorPixelEsquerda = _getpixel32(this->mapaDeColisao, p1->getPosicaoX() - cenario + 4, p1->getPosicaoY() + p1->getTamanhoY());
    int valorPixelMedio = _getpixel32(this->mapaDeColisao, p1->getPosicaoX() - cenario + ((p1->getTamanhoX())/2) , p1->getPosicaoY() + p1->getTamanhoY());
    int valorPixelDireita = _getpixel32(this->mapaDeColisao, p1->getPosicaoX() - cenario + p1->getTamanhoX() - 4, p1->getPosicaoY() + p1->getTamanhoY());
    int vida = true;
    int coordY = p1->getPosicaoY();
    int vermelho = makecol(255,0,0);
    int passos = 0;
    while(valorPixelEsquerda != 0 && valorPixelMedio != 0 && valorPixelDireita != 0 && vida){
        passos++;
        coordY++;
        valorPixelEsquerda = _getpixel32(this->mapaDeColisao, p1->getPosicaoX() - cenario +4 , coordY + p1->getTamanhoY());
        valorPixelMedio = _getpixel32(this->mapaDeColisao, p1->getPosicaoX() - cenario + ((p1->getTamanhoX())/2) , coordY + p1->getTamanhoY());
        valorPixelDireita = _getpixel32(this->mapaDeColisao, p1->getPosicaoX() - cenario + p1->getTamanhoX()-4, coordY + p1->getTamanhoY());
        if(valorPixelEsquerda == vermelho || valorPixelMedio == vermelho || valorPixelDireita == vermelho){
            vida = false;
        }
    }
    this->retorno->retornoColisao = passos;
    this->retorno->vivo = vida;
}

void ColisaoEstatica::subindo(Personagem* p1, int cenario){
   int valorPixelEsquerda = _getpixel32(this->mapaDeColisao, p1->getPosicaoX() - cenario+4, p1->getPosicaoY());
    int valorPixelMedio = _getpixel32(this->mapaDeColisao, p1->getPosicaoX() - cenario + ((p1->getTamanhoX())/2) , p1->getPosicaoY());
    int valorPixelDireita = _getpixel32(this->mapaDeColisao, p1->getPosicaoX() -cenario+ p1->getTamanhoX()-4, p1->getPosicaoY());

    int coordY = p1->getPosicaoY();
    int vida = true;
    int vermelho = makecol(255,0,0);
    int azul = makecol(0,0,255);
    int passos = 0;
    while(valorPixelEsquerda != 0 && valorPixelMedio != 0 && valorPixelDireita != 0 && vida){

        passos++;
        coordY--;
        valorPixelEsquerda = _getpixel32(this->mapaDeColisao, p1->getPosicaoX() - cenario+4, coordY );
        valorPixelMedio = _getpixel32(this->mapaDeColisao, p1->getPosicaoX() - cenario + ((p1->getTamanhoX())/2) , coordY );
        valorPixelDireita = _getpixel32(this->mapaDeColisao, p1->getPosicaoX() - cenario + p1->getTamanhoX()-4, coordY );
        if(valorPixelEsquerda == vermelho || valorPixelMedio == vermelho || valorPixelDireita == vermelho){
            vida = false;
        }


    }
    this->retorno->retornoColisao = passos;
    this->retorno->vivo = vida;

}

void ColisaoEstatica::colisaoDireita(Personagem* pers, int cenario){
    int valorPixelCima = _getpixel32(this->mapaDeColisao, ( pers->getPosicaoX() + pers->getTamanhoX()- cenario )  , pers->getPosicaoY() );
    int valorPixelMeio = _getpixel32(this->mapaDeColisao, ( pers->getPosicaoX() + pers->getTamanhoX()- cenario )  , (pers->getPosicaoY() + pers->getTamanhoY()/2) );
    int valorPixelBaixo = _getpixel32(this->mapaDeColisao, (pers->getPosicaoX() + pers->getTamanhoX()- cenario)  , (pers->getPosicaoY() + pers->getTamanhoY())-4 );
    int coordX = pers->getPosicaoX()+pers->getTamanhoX()- cenario;
    int passos = 0;
    int vermelho = makecol(255,0,0);
    int amarelo = makecol(255,255,0);
    int azul = makecol(0,0,255);
    int vida = true;
        while(valorPixelCima != 0 && valorPixelMeio != 0 && valorPixelBaixo != 0 && passos<6){
            coordX++;
            passos++;
            valorPixelCima = _getpixel32(this->mapaDeColisao,  coordX   , pers->getPosicaoY() );
            valorPixelMeio = _getpixel32(this->mapaDeColisao,  coordX   , (pers->getPosicaoY() + pers->getTamanhoY()/2) );
            valorPixelBaixo = _getpixel32(this->mapaDeColisao, coordX   , (pers->getPosicaoY() + pers->getTamanhoY()) -4);
            if(valorPixelCima == vermelho || valorPixelMeio == vermelho || valorPixelBaixo == vermelho){
                vida = false;
            }
            if(valorPixelCima == amarelo || valorPixelMeio == amarelo || valorPixelBaixo == amarelo){
                this->acabouEstagio = true;
            }

        }
       this->retorno->retornoColisao = passos;
        this->retorno->vivo = vida;

}

void ColisaoEstatica::colisaoEsquerda(Personagem* pers, int cenario){
    int valorPixelCima = _getpixel32(this->mapaDeColisao, ( pers->getPosicaoX() - cenario )  , pers->getPosicaoY() );
    int valorPixelMeio = _getpixel32(this->mapaDeColisao, ( pers->getPosicaoX() - cenario )  , (pers->getPosicaoY() + pers->getTamanhoY()/2) );
    int valorPixelBaixo = _getpixel32(this->mapaDeColisao, (pers->getPosicaoX() - cenario )  , (pers->getPosicaoY() + pers->getTamanhoY())-4);
        int coordX = pers->getPosicaoX()- cenario;
        int passos = 0;
        bool vida = true;
        int vermelho = makecol(255,0,0);
        int azul = makecol(0,0,255);
        while(valorPixelCima != 0 && valorPixelMeio != 0 && valorPixelBaixo != 0 && passos<6 ){
            coordX--;
            passos++;
            valorPixelCima = _getpixel32(this->mapaDeColisao,  coordX   , pers->getPosicaoY() );
            valorPixelMeio = _getpixel32(this->mapaDeColisao,  coordX   , (pers->getPosicaoY() + pers->getTamanhoY()/2) );
            valorPixelBaixo = _getpixel32(this->mapaDeColisao, coordX   , (pers->getPosicaoY() + pers->getTamanhoY())-4);
            if(valorPixelCima == vermelho || valorPixelMeio == vermelho || valorPixelBaixo == vermelho){
                vida = false;
            }

        }
        this->retorno->retornoColisao = passos;
        this->retorno->vivo = vida;

}

RetornoEstatica* ColisaoEstatica::getRetorno(){
    return this->retorno;
}
