#include <allegro.h>
#include <cmath>
#include <cstdlib>
#include <stdio.h>
#include <fstream>
#include <iostream>

#include "ConstantesDeConfiguracao.h"
#include "ConstantesDeDados.h"
#include "PersonagemPrincipal.h"
#include "Inimigo.h"
#include "Controle.h"
#include "ObjetoRetornoColisao.h"
#include "ColisaoDinamica.h"

using namespace std;

servidor Controle::rodando(bool sair, bool pausado,bool umPlayer, int teclaClicada1, int teclaClicada2) {
    int retorno = 0;
    if (pausado) {
        retorno = PAUSADO;
    } else if (sair) {
        retorno = SAIR;
    } else {
        retorno = this->controleTotal(umPlayer,teclaClicada1,teclaClicada2);
    }
	servidor* retornoControle = (servidor *)malloc(sizeof(servidor));
	retornoControle->respostaControle = retorno;
	retornoControle->umJogador = umPlayer;
	this->iniciarRetorno(retornoControle);
    return *retornoControle;
}

void Controle::mudarEstagio(char *enderecoDoMapaDeColisao, char *enderecoDoArquivoDePosicoesDosInimigos) {
    delete(this->mario);
    delete(this->luigi);
    delete [] this->inimigos;
    delete(this->colisaoAe);
    delete(this->colisaoEst);

    ifstream arquivo(enderecoDoArquivoDePosicoesDosInimigos, ios::in);

    int x;
    int y;
    int velocidade;
    int tamanhoX;
    int tamanhoY;
    int tipo;

    arquivo >> x;
    arquivo >> y;
    arquivo >> velocidade;
    arquivo >> tamanhoX;
    arquivo >> tamanhoY;
    arquivo >> tipo;

    this->luigi = new PersonagemPrincipal(x, y, velocidade, tamanhoX, tamanhoY, tipo);
    this->posicaoIniLuigi = y;
    this->tempoLuigi = 32;
    this->luigi->setVivo(true);

    arquivo >> x;
    arquivo >> y;
    arquivo >> velocidade;

    arquivo >> tamanhoX;
    arquivo >> tamanhoY;
    arquivo >> tipo;


    if (!this->singlePlayer) {
        this->mario = new PersonagemPrincipal(x, y, velocidade, tamanhoX, tamanhoY, tipo);
        this->tempoMario = 32;
        this->posicaoIniMario = y;
    } else {
        this->mario = new PersonagemPrincipal(x, y, velocidade, tamanhoX, tamanhoY, tipo);
        this->mario->setVivo(false);
    }
    this->descer = true;

    this->coordenadaXDoCenario = 0;
    this->mapaDeColisao = load_bitmap(enderecoDoMapaDeColisao, NULL);


    // INICIALIZAO DE INIMIGOS
    arquivo >> this->numeroDeInimigos;

    this->inimigos = new Personagem*[this->numeroDeInimigos];
    this->colisaoAe = new ColisaoDinamica(this->inimigos,this->numeroDeInimigos);
    this->colisaoEst = new ColisaoEstatica(this->mapaDeColisao);


    for (int i = 0; i < this->numeroDeInimigos; i++) {
        arquivo >> x;
        arquivo >> y;
        arquivo >> velocidade;
        arquivo >> tamanhoX;
        arquivo >> tamanhoY;
        arquivo >> tipo;
        Personagem* inimigo = new Inimigo(x, y, velocidade, tamanhoX, tamanhoY, tipo);
        this->inimigos[i] = inimigo;
    }
    arquivo.close();
}

Controle::~Controle() {
    delete luigi;
    delete mario;
    delete[] inimigos;
    delete colisaoAe;
    delete colisaoEst;
    destroy_bitmap(this->mapaDeColisao);
}

Controle::Controle(bool singlePlayer, char *enderecoDoMapaDeColisao, char *enderecoDoArquivoDePosicoesDosInimigos) {
    this->cenarioAndandoE = false;
    this->cenarioAndandoD = false;
    this->singlePlayer = singlePlayer;

    ifstream arquivo(enderecoDoArquivoDePosicoesDosInimigos, ios::in);

    int x;
    int y;
    int velocidade;
    int tamanhoX;
    int tamanhoY;
    int tipo;

    arquivo >> x;
    arquivo >> y;
    arquivo >> velocidade;
    arquivo >> tamanhoX;
    arquivo >> tamanhoY;
    arquivo >> tipo;

    this->luigi = new PersonagemPrincipal(x, y, velocidade, tamanhoX, tamanhoY, tipo);
    this->posicaoIniLuigi = y;
    this->tempoLuigi = 32;
    this->luigi->setVivo(true);

    arquivo >> x;
    arquivo >> y;
    arquivo >> velocidade;

    arquivo >> tamanhoX;
    arquivo >> tamanhoY;
    arquivo >> tipo;


    if (!this->singlePlayer) {
        this->mario = new PersonagemPrincipal(x, y, velocidade, tamanhoX, tamanhoY, tipo);
        this->tempoMario = 32;
        this->posicaoIniMario = y;
    } else {
        this->mario = new PersonagemPrincipal(x, y, velocidade, tamanhoX, tamanhoY, tipo);
        this->mario->setVivo(false);
    }
    this->descer = true;

    this->coordenadaXDoCenario = 0;
    this->mapaDeColisao = load_bitmap(enderecoDoMapaDeColisao, NULL);


    // INICIALIZAO DE INIMIGOS
    arquivo >> this->numeroDeInimigos;

    this->inimigos = new Personagem*[this->numeroDeInimigos];
    this->colisaoAe = new ColisaoDinamica(this->inimigos,this->numeroDeInimigos);
    this->colisaoEst = new ColisaoEstatica(this->mapaDeColisao);


    for (int i = 0; i < this->numeroDeInimigos; i++) {
        arquivo >> x;
        arquivo >> y;
        arquivo >> velocidade;
        arquivo >> tamanhoX;
        arquivo >> tamanhoY;
        arquivo >> tipo;
        Personagem* inimigo = new Inimigo(x, y, velocidade, tamanhoX, tamanhoY, tipo);
        this->inimigos[i] = inimigo;
    }
    arquivo.close();
}

int Controle::getCoordenadaXDoCenario() {
    return this->coordenadaXDoCenario;
}

void Controle::processarEntrada(Personagem* pers,int teclaClicada) {
    switch (teclaClicada) {
    case CIMA:
        if (pers->getEstadoY() == PARADO) {
            if (pers->getTipo() == MARIO) {
                this->tempoMario = 0;
                this->posicaoIniMario = pers->getPosicaoY();
            } else {
                this->tempoLuigi = 0;
                this->posicaoIniLuigi = pers->getPosicaoY();
            }
            descer = false;
            pers->setEstadoY(PULANDO);
        }
        if (pers->getTipo()== MARIO) {
                int colisaoMovimentadaEsquerda;
                int colisaoMovimentadaDireita;
                colisaoMovimentadaEsquerda = this->colisaoAe->verificarColisaoEsquerdaEmInimigos(this->mario,1);
                colisaoMovimentadaDireita = this->colisaoAe->verificarColisaoDireitaEmInimigos(this->mario,1);
                if (colisaoMovimentadaEsquerda == 1 || colisaoMovimentadaDireita == 1) {
                    this->mario->setVivo(false);
                }
        } else {
                int colisaoMovimentadaEsquerda;
                int colisaoMovimentadaDireita;
                colisaoMovimentadaEsquerda = this->colisaoAe->verificarColisaoEsquerdaEmInimigos(this->luigi,0);
                colisaoMovimentadaDireita = this->colisaoAe->verificarColisaoDireitaEmInimigos(this->luigi,0);
                if (colisaoMovimentadaEsquerda == 1 || colisaoMovimentadaDireita == 1) {
                    this->luigi->setVivo(false);
                }
        }
        break;

    case DIREITA:
        if (!pers->getViradoPraFrente()) {
            pers->setViradoPraFrente(true);
        } else {
            int colisaoMovimentada = 0;
            if (pers->getTipo()== MARIO /*&& pers->getEstadoY() != CAINDO*/) {
                colisaoMovimentada = this->colisaoAe->verificarColisaoDireitaEmInimigos(this->mario,this->mario->getVelocidade());
            } else { /*if(pers->getEstadoY() != CAINDO)*/
                colisaoMovimentada = this->colisaoAe->verificarColisaoDireitaEmInimigos(this->luigi,this->luigi->getVelocidade());
            }
            if (colisaoMovimentada == 3 || pers->getEstadoY() != PARADO) {

                //ERRO NA COLISO ESTTICA!!!!
                this->colisaoEst->colisaoDireita(pers,this->coordenadaXDoCenario);

                int passos = this->colisaoEst->getRetorno()->retornoColisao;
                if (passos > pers->getVelocidade()) {
                    if (pers->getPosicaoX() >= 540) {
                        if (pers->getTipo() ==  MARIO) {
                            if (this->luigi->getPosicaoX() > 70 || !this->luigi->getVivo()) {
                                this->coordenadaXDoCenario -= pers->getVelocidade();
                                this->luigi->decrementarPocisaoX(pers->getVelocidade());
                                this->cenarioAndandoE = true;
                            }
                        } else {
                            if (this->mario->getPosicaoX() > 70 || !this->mario->getVivo()) {
                                this->coordenadaXDoCenario -= pers->getVelocidade();
                                 this->cenarioAndandoE = true;
                                if (this->mario->getVivo())this->mario->decrementarPocisaoX(pers->getVelocidade());
                            }

                        }
                       /* Personagem** temp = this->inimigos;
                        for (int i =0; i<this->numeroDeInimigos;i++) {
                            this->mazelando(temp[i]);
                            /*if(temp[i]->getViradoPraFrente()){
                                temp[i]->decrementarPocisaoX(pers->getVelocidade());
                            }else{
                                temp[i]->incrementarPocisaoX(pers->getVelocidade());
                            }
                        }*/
                    } else {
                        this->cenarioAndandoE = false;
                        if (this->colisaoEst->getRetorno()->vivo) {
                            pers->setPosicaoX(pers->getPosicaoX() + pers->getVelocidade());
                        } else {
                            pers->setVivo(false);
                        }
                    }
                    pers->setEstadoX(ANDANDO);
                    pers->setIndiceAndando(pers->getIndiceAndando()+1);
                } else {
                    this->cenarioAndandoE = false;
                    pers->setPosicaoX(pers->getPosicaoX() + passos);
                }
                pers->setEstadoX(ANDANDO);
                pers->setIndiceAndando(pers->getIndiceAndando()+1);
            } else {
                if (this->colisaoAe->getRetornoColisao()->getTipoDeColisao() == 1) {
                    if (pers->getTipo() == MARIO)this->mario->setVivo(false);
                    else this->luigi->setVivo(false);
                }
            }



        }
        break;
    case ESQUERDA:
        if (pers->getViradoPraFrente()) {
            pers->setViradoPraFrente(false);
        } else {
            int colisaoMovimentada;
            if (pers->getTipo()==MARIO) {
                colisaoMovimentada = this->colisaoAe->verificarColisaoEsquerdaEmInimigos(this->mario,this->mario->getVelocidade());
            } else {
                colisaoMovimentada = this->colisaoAe->verificarColisaoEsquerdaEmInimigos(this->luigi,this->luigi->getVelocidade());
            }
            if (colisaoMovimentada == 3 || pers->getEstadoY()!=PARADO) {
                this->colisaoEst->colisaoEsquerda(pers,this->coordenadaXDoCenario);
                int passos = this->colisaoEst->getRetorno()->retornoColisao;
                if (passos > pers->getVelocidade()) {
                    if (pers->getPosicaoX() < 70 && this->coordenadaXDoCenario < 0) {
                        if (pers->getTipo() == MARIO) {
                            if (this->luigi->getPosicaoX() < 540 || !this->luigi->getVivo()) {
                                this->coordenadaXDoCenario += pers->getVelocidade();
                                this->luigi->incrementarPocisaoX(pers->getVelocidade());
                                this->cenarioAndandoD = true;
                            }

                            //BUG DE PARAR OS INIMIGOS CASO NAO COLOCAR!!!!!!

                        } else {
                            if (this->mario->getPosicaoX() <540 || !this->mario->getVivo()) {
                                this->cenarioAndandoD = true;
                                this->coordenadaXDoCenario += pers->getVelocidade();
                                if (this->mario->getVivo())this->mario->incrementarPocisaoX(pers->getVelocidade());
                            }
                            //BUG DE PARAR OS INIMIGOS CASO NAO COLOCAR!!!!!!

                        }
                        /*Personagem** temp = this->inimigos;
                        for (int i =0; i<this->numeroDeInimigos;i++) {
                            this->mazelando(temp[i]);
                            //temp[i]->incrementarPocisaoX(temp[i]->getVelocidade());
                        }*/
                    } else {
                        this->cenarioAndandoD = false;
                        if (this->colisaoEst->getRetorno()->vivo) {
                            pers->setPosicaoX(pers->getPosicaoX() - pers->getVelocidade());
                        } else {
                            pers->setVivo(false);
                        }

                    }
                } else {
                    this->cenarioAndandoD = false;
                    pers->setPosicaoX(pers->getPosicaoX() - passos);
                }
                pers->setEstadoX(ANDANDO);
                pers->setIndiceAndando(pers->getIndiceAndando()+1);
            } else {
                if (this->colisaoAe->getRetornoColisao()->getTipoDeColisao() == 1) {
                    if (pers->getTipo() == MARIO)this->mario->setVivo(false);
                    else this->luigi->setVivo(false);
                }
            }

        }
        break;
    case NENHUMA_TECLA_CLICADA:
       // this->cenarioAndandoD = false;
       // this->cenarioAndandoE = false;
        if(pers->getVivo() == true){
         if (pers->getTipo()== MARIO) {
            if (this->mario->getEstadoY() == PARADO) {
                int colisaoMovimentadaEsquerda = 0;
                int colisaoMovimentadaDireita = 0;
                colisaoMovimentadaEsquerda = this->colisaoAe->verificarColisaoEsquerdaEmInimigos(this->mario,1);
                colisaoMovimentadaDireita = this->colisaoAe->verificarColisaoDireitaEmInimigos(this->mario,1);
                if (colisaoMovimentadaEsquerda == 1 || colisaoMovimentadaDireita == 1) {
                    this->mario->setVivo(false);
                }
            }

        } else {
            if (this->luigi->getEstadoY() ==PARADO) {
                int colisaoMovimentadaEsquerda;
                int colisaoMovimentadaDireita;
                colisaoMovimentadaEsquerda = this->colisaoAe->verificarColisaoEsquerdaEmInimigos(this->luigi,1);
                colisaoMovimentadaDireita = this->colisaoAe->verificarColisaoDireitaEmInimigos(this->luigi,1);
                if (colisaoMovimentadaEsquerda == 1 || colisaoMovimentadaDireita == 1) {
                    this->luigi->setVivo(false);
                }
            }
        }

        pers->setEstadoX(PARADO);
        }
        break;
    }


}

void Controle::mazelando(Personagem* inimigo) {
    if (inimigo->getViradoPraFrente()) {
        if(!cenarioAndandoE && !cenarioAndandoD){
            int passos = this->colisaoDireita(inimigo, 0);
            if (passos > inimigo->getVelocidade()) {
                inimigo->incrementarPocisaoX(inimigo->getVelocidade());
            } else {
                inimigo->incrementarPocisaoX(passos);
                inimigo->setViradoPraFrente(false);
            }
        }else if (cenarioAndandoE){
           int passos = this->colisaoDireita(inimigo, -5);
            if (passos > inimigo->getVelocidade()) {
                inimigo->incrementarPocisaoX(inimigo->getVelocidade() - 5);
            } else {
                inimigo->incrementarPocisaoX(passos);
                inimigo->setViradoPraFrente(false);
            }
        }else{
             int passos = this->colisaoDireita(inimigo, 5);
            if (passos > inimigo->getVelocidade()) {
                inimigo->incrementarPocisaoX(inimigo->getVelocidade() + 5);
            } else {
                inimigo->incrementarPocisaoX(passos);
                inimigo->setViradoPraFrente(false);
            }
        }
    } else {
        if(!cenarioAndandoE && !cenarioAndandoD){
            int passos = this->colisaoEsquerda(inimigo, 0);
            if (passos > inimigo->getVelocidade()) {
                inimigo->decrementarPocisaoX(inimigo->getVelocidade());
            } else {
                inimigo->decrementarPocisaoX(passos);
                inimigo->setViradoPraFrente(true);
            }
        }else if(cenarioAndandoE){
           int passos = this->colisaoEsquerda(inimigo, -5);
            if (passos > inimigo->getVelocidade()) {
                inimigo->decrementarPocisaoX(inimigo->getVelocidade() + 5);
            } else {
                inimigo->decrementarPocisaoX(passos);
                inimigo->setViradoPraFrente(true);
            }
        }else{
             int passos = this->colisaoEsquerda(inimigo, 5);
            if (passos > inimigo->getVelocidade()) {
                inimigo->decrementarPocisaoX(inimigo->getVelocidade() - 5);
            } else {
                inimigo->decrementarPocisaoX(passos);
                inimigo->setViradoPraFrente(true);
            }
        }
    }
    inimigo->setEstadoX(ANDANDO);
}

void Controle::controlarInimigos() {
    for (int i = 0; i < this->numeroDeInimigos; i++) {
        this->mazelando(this->inimigos[i]);
    }
}

int Controle::controleTotal(bool umPlayer,int teclaClicada1,int teclaClicada2) {
    this->cenarioAndandoE = false;
    this->cenarioAndandoD = false;
    if(this->luigi->getVivo()){
        this->gravidadeLuigi();
        this->verificarResultadoColisao();
        this->processarEntrada(this->luigi,teclaClicada1);
        this->verificarResultadoColisao();
    }
    if (!umPlayer) {
        if(this->mario->getVivo()){
            this->gravidadeMario();
            this->verificarResultadoColisao();
            this->processarEntrada(this->mario,teclaClicada2);
            this->verificarResultadoColisao();
        }
    }

    this->controlarInimigos();

    if (this->colisaoEst->acabouEstagio) {
        return ACABOU_FASE;
    } else if (!this->mario->getVivo() && !this->luigi->getVivo()) {
        return MORREU;
    } else {
        return 0;
    }

}

void Controle::verificarResultadoColisao() {
    ObjetoRetornoColisao *temp = this->colisaoAe->getRetornoColisao();
    if (temp->getTipoDeColisao() == 1) {

    } else if (temp->getTipoDeColisao() == 2) {
        temp->getInimigo()->setVivo(false);
    }

}

void Controle::gravidadeMario() {

    int novaPosicao = this->posicaoIniMario - this->mario->getVelocidade()*this->tempoMario + (1*(this->tempoMario*this->tempoMario))/8;
    if (this->mario->getEstadoY() == PULANDO ) {
        this->colisaoEst->subindo(this->mario,this->coordenadaXDoCenario);
        int posicaoPraColidirCima = -this->colisaoEst->getRetorno()->retornoColisao + this->mario->getPosicaoY();
        if (posicaoPraColidirCima < novaPosicao) {
            this->mario->setPosicaoY(novaPosicao);
            this->tempoMario+=2;
        } else {
            if (this->colisaoEst->getRetorno()->vivo) {
                this->mario->setPosicaoY(posicaoPraColidirCima);
                this->mario->setEstadoY(CAINDO);
                this->tempoMario=32-this->tempoMario+10;
            } else {
                this->mario->setVivo(false);
            }
        }
        if (this->tempoMario == 16)this->mario->setEstadoY(CAINDO);
    } else {
        this->colisaoEst->caindo(this->mario,this->coordenadaXDoCenario);
        int posicaoPraColidirBaixo = this->colisaoEst->getRetorno()->retornoColisao+this->mario->getPosicaoY();
        int colisaoD = 3;
        if(this->mario->getEstadoY() == CAINDO) colisaoD = this->colisaoAe->verificarColisaoCimaEmInimigos(this->mario,novaPosicao);
        if (colisaoD == 2) {
            if(this->mario->getEstadoY() == CAINDO){
                this->posicaoIniMario = this->mario->getPosicaoY();
                this->tempoMario = 0;
                this->mario->setEstadoY(PULANDO);
            }else{
                this->mario->setVivo(false);
            }
        } else if (posicaoPraColidirBaixo > novaPosicao ) {

            this->mario->setPosicaoY(novaPosicao);
            this->tempoMario+=2;
            this->mario->setEstadoY(CAINDO);
        } else {
            if (this->colisaoEst->getRetorno()->vivo) {

                this->mario->setPosicaoY(posicaoPraColidirBaixo);
                this->mario->setEstadoY(PARADO);
            } else {

                this->mario->setVivo(false);
            }
        }
    }
}

void Controle::gravidadeLuigi() {
    int novaPosicao = this->posicaoIniLuigi - this->luigi->getVelocidade()*this->tempoLuigi + (1*(this->tempoLuigi*this->tempoLuigi))/8;
    if (this->luigi->getEstadoY() == PULANDO) {
        this->colisaoEst->subindo(this->luigi,this->coordenadaXDoCenario);
        int posicaoPraColidirCima = -this->colisaoEst->getRetorno()->retornoColisao+this->luigi->getPosicaoY();
        if (posicaoPraColidirCima < novaPosicao) {
            this->luigi->setPosicaoY(novaPosicao);
            this->tempoLuigi+=2;
        } else {
            if (this->colisaoEst->getRetorno()->vivo) {
                this->luigi->setPosicaoY(posicaoPraColidirCima);
                this->luigi->setEstadoY(CAINDO);
                this->tempoLuigi=32-this->tempoLuigi+10;
            } else {
                this->luigi->setVivo(false);
            }
        }
        if (tempoLuigi >= 16)this->luigi->setEstadoY(CAINDO);
    } else { /*if(this->luigi->getEstadoY() == CAINDO)*/
        this->colisaoEst->caindo(this->luigi,this->coordenadaXDoCenario);
        int posicaoPraColidirBaixo = this->colisaoEst->getRetorno()->retornoColisao+this->luigi->getPosicaoY();
        int colisaoD = 3;
        if(this->luigi->getEstadoY() == CAINDO) colisaoD = this->colisaoAe->verificarColisaoCimaEmInimigos(this->luigi,posicaoPraColidirBaixo);
        if (colisaoD == 2 ){
                this->posicaoIniLuigi = this->luigi->getPosicaoY();
                this->tempoLuigi = 0;
                this->luigi->setEstadoY(PULANDO);
        } else if (posicaoPraColidirBaixo > novaPosicao ) {
            this->luigi->setPosicaoY(novaPosicao);
            this->tempoLuigi+=2;
            this->luigi->setEstadoY(CAINDO);
        } else {
            if (this->colisaoEst->getRetorno()->vivo) {
                this->luigi->setPosicaoY(posicaoPraColidirBaixo);
                this->luigi->setEstadoY(PARADO);
            } else {
                this->luigi->setVivo(false);
            }
        }
    }
}

int Controle::colisaoDireita(Personagem* pers, int relativo) {
    int valorPixelCima = _getpixel32(this->mapaDeColisao, ( relativo + pers->getPosicaoX() + pers->getTamanhoX()- this->coordenadaXDoCenario )  , pers->getPosicaoY() );
    int valorPixelMeio = _getpixel32(this->mapaDeColisao, ( relativo + pers->getPosicaoX() + pers->getTamanhoX()- this->coordenadaXDoCenario )  , (pers->getPosicaoY() + pers->getTamanhoY()/2) );
    int valorPixelBaixo = _getpixel32(this->mapaDeColisao, (relativo +pers->getPosicaoX() + pers->getTamanhoX()- this->coordenadaXDoCenario )  , (pers->getPosicaoY() + pers->getTamanhoY())-4 );
    int coordX = relativo + pers->getPosicaoX()+pers->getTamanhoX()- this->coordenadaXDoCenario;
    int passos = 0;

    while (valorPixelCima != 0 && valorPixelMeio != 0 && valorPixelBaixo != 0) {
        coordX++;
        passos++;
        valorPixelCima = _getpixel32(this->mapaDeColisao,  coordX   , pers->getPosicaoY() );
        valorPixelMeio = _getpixel32(this->mapaDeColisao,  coordX   , (pers->getPosicaoY() + pers->getTamanhoY()/2) );
        valorPixelBaixo = _getpixel32(this->mapaDeColisao, coordX   , (pers->getPosicaoY() + pers->getTamanhoY()) -4);

    }
    return passos;
}

int Controle::colisaoEsquerda(Personagem* pers, int relativo) {
    int valorPixelCima = _getpixel32(this->mapaDeColisao, (relativo +  pers->getPosicaoX() - this->coordenadaXDoCenario )  , pers->getPosicaoY() );
    int valorPixelMeio = _getpixel32(this->mapaDeColisao, (relativo + pers->getPosicaoX() - this->coordenadaXDoCenario )  , (pers->getPosicaoY() + pers->getTamanhoY()/2) );
    int valorPixelBaixo = _getpixel32(this->mapaDeColisao, (relativo + pers->getPosicaoX() - this->coordenadaXDoCenario )  , (pers->getPosicaoY() + pers->getTamanhoY())-4 );
    int coordX =relativo + pers->getPosicaoX()- this->coordenadaXDoCenario;
    int passos = 0;

    while (valorPixelCima != 0 && valorPixelMeio != 0 && valorPixelBaixo != 0 ) {
        coordX++;
        passos++;
        valorPixelCima = _getpixel32(this->mapaDeColisao,  coordX   , pers->getPosicaoY() );
        valorPixelMeio = _getpixel32(this->mapaDeColisao,  coordX   , (pers->getPosicaoY() + pers->getTamanhoY()/2) );
        valorPixelBaixo = _getpixel32(this->mapaDeColisao, coordX   , (pers->getPosicaoY() + pers->getTamanhoY()) -4);

    }
    return passos;
}

Personagem** Controle::getArrayInimigos() {
    return this->inimigos;
}

int Controle::getQuantidadeDeInimigos() {
    return this->numeroDeInimigos;
}

Personagem *Controle::getLuigi() {
    return this->luigi;
}

Personagem *Controle::getMario() {
    return this->mario;
}

bool Controle::getUmJogador() {
    return this->singlePlayer;
}

void Controle::iniciarRetorno(servidor* retorno){
	retorno->coordenadaCenario = this->coordenadaXDoCenario;
	retorno->statusLuigi = this->luigi->getStatus();
	retorno->statusMario = this->mario->getStatus();
	retorno->viradoFrenteLuigi = this->luigi->getViradoPraFrente();
	retorno->viradoFrenteMario = this->mario->getViradoPraFrente();
	retorno->vivoLuigi = this->luigi->getVivo();
	retorno->vivoMario = this->mario->getVivo();
	retorno->xLuigi = this->luigi->getPosicaoX();
	retorno->yLuigi = this->luigi->getPosicaoY();
	retorno->xMario = this->mario->getPosicaoX();
	retorno->yMario = this->mario->getPosicaoY();
	retorno->estadoXLuigi = this->luigi->getEstadoX();
	retorno->estadoXMario = this->mario->getEstadoX();
	retorno->estadoYLuigi = this->luigi->getEstadoY();
	retorno->estadoYMario = this->mario->getEstadoY();
	retorno->indiceAndandoLuigi = this->luigi->getIndiceAndando();
	retorno->indiceAndandoMario = this->mario->getIndiceAndando();
	retorno->quantidadeInimigos = this->numeroDeInimigos;
	for(int i = 0; i< this->numeroDeInimigos;i++){
		retorno->inimigoIndiceAndando[i] = this->inimigos[i]->getIndiceAndando();
		retorno->inimigoViradoFrente[i] = this->inimigos[i]->getViradoPraFrente();
		retorno->inimigoVivo[i] = this->inimigos[i]->getVivo();
		retorno->xInimigo[i] = this->inimigos[i]->getPosicaoX();
		retorno->yInimigo[i] = this->inimigos[i]->getPosicaoY();
	}
}

