#ifndef CONTROLE_H_INCLUDED
#define CONTROLE_H_INCLUDED

#include "servidor.h"
#include "Personagem.h"
#include "Inimigo.h"
#include "ColisaoDinamica.h"
#include "ColisaoEstatica.h"

class Controle {

    private:
        int coordenadaXDoCenario;
        int posicaoIniMario;
        int posicaoIniLuigi;
        int posicaoIni;
        int numeroDeInimigos;
        int tempoMario;
        int tempoLuigi;
        bool singlePlayer;
        bool descer;
        bool cenarioAndandoD;
        bool cenarioAndandoE;
        Personagem **inimigos;
        Personagem *mario;
        Personagem *luigi;

        ColisaoDinamica* colisaoAe;
        ColisaoEstatica* colisaoEst;
        BITMAP *mapaDeColisao; // ARQUIVO .bmp que vai ficar apenas no SERVIDOR, pois so interessa a ele

    public:

        Controle(bool, char *, char*);
        ~Controle();

        bool verificarColisaoDeCenario(Personagem *, int);
        bool verificarSeInimigoTaNaTela(Inimigo *);
        bool getUmJogador();

        servidor rodando(bool,bool,bool,int,int);
        int getQuantidadeDeInimigosQueEstaoNaAreaVisual();
        int caindo(Personagem *, int);
        int subindo(Personagem*, int);
        int colisaoDireita(Personagem*, int);
        int colisaoEsquerda(Personagem*, int);
        int controleTotal(bool, int,int);
        int getCoordenadaXDoCenario();
        int getQuantidadeDeInimigos();
		
		void iniciarRetorno(servidor*);
        void mudarEstagio(char*, char*);
        void mazelando(Personagem *);
        void controlarInimigos();
        void processarEntrada(Personagem*,int);
        void processarEntradaMario(int);
        void mexerComAColisaoNaVidaDoBoneco(int , int , int);
        void gravidade(Personagem*);
        void gravidadeMario();
        void gravidadeMarioAsa();
        void gravidadeLuigi();
        void gravidadeLuigiAsa();
        void verificarResultadoColisao();
        Inimigo **getInimigosQueEstaoNaAreaVisual();
        Personagem** getArrayInimigos();

        Personagem *getMario();
        Personagem *getLuigi();

};

#endif // CONTROLE_H_INCLUDED
