#include <stdio.h>
#include <stdlib.h>
#include "allegro.h"
#include <string.h>
#include <fstream>

#include "Servidor/ConstantesDeConfiguracao.h"
#include "Servidor/Controle.h"
#include "Imagens.h"
#include "GrupoDeImagem.h"
#include "Servidor/ConstantesDeDados.h"
#include "Servidor/Entrada.h"
#include "Saida.h"
#include"Servidor/servidor.h"

using namespace std;

int estagioAtual = 1;
bool inicio = true;
volatile int contador = 0;
bool continua = true;
bool pausado = false;
bool saindo = false;
bool saiu = false;
servidor* respostaControle;

void tratarTeclaPressionadaMenu(int);
void tratarTeclaPressionadaExtra(int);
int inicia(void);
void principal(void);
void finaliza(void);
int getTeclaExtra();
int getTeclaMenu();

void tempo();
int main (void) {
    if (!inicia()) {
        finaliza();
        return -1;
    }
    principal();
    finaliza();
    return 0;
}
END_OF_MAIN();

int inicia (void) {
    allegro_init();

    install_keyboard();
    install_timer();
    LOCK_FUNCTION(tempo);
    LOCK_VARIABLE(contador);
    install_int(tempo,100);
    install_mouse();

    set_color_depth(COLOR_BITS);
    if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, 640, 480, 0,0 )< 0) {
        printf("Erro ao inicializar o modo grafico.\n");
        return (FALSE);
    }

    //Msica de fundo do jogo (Comentado devido a incompatipilidade em alguns computadores)
    /*if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL) < 0) {
      printf("Erro ao inicializar o som.\n");
      return (FALSE);
    }*/

    return (TRUE);

}

void finaliza (void) {
    clear_keybuf();
    allegro_exit();
}

int getTeclaExtra() {
    if (key[KEY_P]) {
        return PAUSE;
    } else if (key[KEY_J]) {
        return MUDAR_DE_ESTAGIO;
    } else if (key[KEY_ESC]) {
        return ESC;
    } else if (key[KEY_ENTER]) {
        return ENTER;
    } else {
        return NENHUMA_TECLA_CLICADA;
    }
}

int getTeclaMenu() {
    if (key[KEY_LEFT]) {
        return ESQUERDA;
    } else if (key[KEY_RIGHT]) {
        return DIREITA;
    }  else if (key[KEY_ENTER]) {
        return ENTER;
    } else {
        return NENHUMA_TECLA_CLICADA;
    }
}

void tempo() {
    contador++;
}
END_OF_FUNCTION(tempo);

void tratarTeclaPressionadaMenu(int tecla) {
    bool aindaPressionando = true;
    while (aindaPressionando) {
        _sleep(40);
        if (getTeclaMenu() == tecla) {
            while (getTeclaMenu() == tecla) {}
            aindaPressionando = false;
        }
    }
}

void tratarTeclaPressionadaExtra(int tecla) {
    bool aindaPressionando = true;
    while (aindaPressionando) {
        _sleep(40);
        if (getTeclaExtra() == tecla) {
            while (getTeclaExtra() == tecla) {}
            aindaPressionando = false;
        }
    }
}

void principal (void) {

    BITMAP *imagemPause = load_bitmap("imagens/sprites/pause.bmp", NULL);
    BITMAP *imagemFinalizar = load_bitmap("imagens/sprites/finalizar.bmp", NULL);
    BITMAP *bufferPause =  create_bitmap(imagemPause->w, imagemPause->h);
    BITMAP *bufferFinalizar =  create_bitmap(imagemFinalizar->w, imagemFinalizar->h);
    bool singlePlayer = false;

    Imagens *imagensFaseAtual;
    Controle *controleFaseAtual;
    Saida *saidaFaseAtual;
    Entrada *entradaFaseAtual;


    bool menuAtivo = true;
    while (menuAtivo) {
        estagioAtual = 1;
        inicio = true;
        pausado = false;
        saindo = false;
        saiu = false;
        continua = true;

        //Imagens do Menu
        BITMAP *bufferMenu = create_bitmap(MAX_X, MAX_Y);
        BITMAP *comecaMenu = load_bitmap("imagens/menu/menu01.bmp", NULL);
        BITMAP *menuComandos = load_bitmap("imagens/menu/menu02.bmp", NULL);
        BITMAP *singlePlayerGrande = load_bitmap("imagens/menu/single_player_grande.bmp", NULL);
        BITMAP *singlePlayerPequeno = load_bitmap("imagens/menu/single_player_pequeno.bmp", NULL);
        BITMAP *multiPlayerGrande = load_bitmap("imagens/menu/multi_player_grande.bmp", NULL);
        BITMAP *multiPlayerPequeno = load_bitmap("imagens/menu/multi_player_pequeno.bmp", NULL);
        BITMAP *comandosGrande = load_bitmap("imagens/menu/comandos_grande.bmp", NULL);
        BITMAP *comandosPequeno = load_bitmap("imagens/menu/comandos_pequeno.bmp", NULL);
        BITMAP *sairGrande = load_bitmap("imagens/menu/sair_grande.bmp", NULL);
        BITMAP *sairPequeno = load_bitmap("imagens/menu/sair_pequeno.bmp", NULL);

        //Colocando na tela imagens do menu
        draw_sprite(bufferMenu, comecaMenu, 0, 0);
        draw_sprite(bufferMenu, singlePlayerGrande, 57, 407);
        draw_sprite(bufferMenu, multiPlayerPequeno, 227, 407);
        draw_sprite(bufferMenu, comandosPequeno, 388, 407);
        draw_sprite(bufferMenu, sairPequeno, 532, 407);

        //Seleo Comea no SinglePlayer
        int indiceDoItemSelecionado = 0;
        bool telaDeComandos = false;
        bool decidiuJogar = false;
        bool decidiuSeVaiSair = false;

        while (!decidiuJogar && !decidiuSeVaiSair) {
            int teclaClicada = getTeclaMenu();

            if (teclaClicada == ENTER) {
                if (indiceDoItemSelecionado == 0) {
                    singlePlayer = true;
                    decidiuJogar = true;
                } else if (indiceDoItemSelecionado == 1) {
                    singlePlayer = false;
                    decidiuJogar = true;
                } else if (indiceDoItemSelecionado == 2) {
                    telaDeComandos = true;
                } else {
                    decidiuSeVaiSair = true;
                    continua = false;
                    menuAtivo = false;
                }
            } else {
                if (teclaClicada == DIREITA) {
                    tratarTeclaPressionadaMenu(DIREITA);
                    indiceDoItemSelecionado = indiceDoItemSelecionado + 1;
                }
                if (teclaClicada == ESQUERDA) {
                    tratarTeclaPressionadaMenu(ESQUERDA);
                    indiceDoItemSelecionado = indiceDoItemSelecionado - 1;
                }

                if (indiceDoItemSelecionado == 4) {
                    indiceDoItemSelecionado = 0;
                }

                if (indiceDoItemSelecionado == -1) {
                    indiceDoItemSelecionado = 3;
                }

                if (telaDeComandos) {
                    draw_sprite(bufferMenu, menuComandos, 0, 0);
                } else {
                    draw_sprite(bufferMenu, comecaMenu, 0, 0);
                }

                //Imprimi com as alteraes
                if (indiceDoItemSelecionado == 0) {
                    draw_sprite(bufferMenu, singlePlayerGrande, 57, 407);
                } else {
                    draw_sprite(bufferMenu, singlePlayerPequeno, 57, 407);
                }

                if (indiceDoItemSelecionado == 1) {
                    draw_sprite(bufferMenu, multiPlayerGrande, 227, 407);
                } else {
                    draw_sprite(bufferMenu, multiPlayerPequeno, 227, 407);
                }

                if (indiceDoItemSelecionado == 2) {
                    draw_sprite(bufferMenu, comandosGrande, 388, 407);
                } else {
                    draw_sprite(bufferMenu, comandosPequeno, 388, 407);
                }

                if (indiceDoItemSelecionado == 3) {
                    draw_sprite(bufferMenu, sairGrande, 532, 407);
                } else {
                    draw_sprite(bufferMenu, sairPequeno, 532, 407);
                }

                draw_sprite(screen, bufferMenu, 0, 0);
            }
        }

        //Desalocando a memria relativa ao menu
        destroy_bitmap(bufferMenu);
        destroy_bitmap(comecaMenu);
        destroy_bitmap(menuComandos);
        destroy_bitmap(singlePlayerGrande);
        destroy_bitmap(singlePlayerPequeno);
        destroy_bitmap(multiPlayerGrande);
        destroy_bitmap(multiPlayerPequeno);
        destroy_bitmap(comandosGrande);
        destroy_bitmap(comandosPequeno);
        destroy_bitmap(sairGrande);
        destroy_bitmap(sairPequeno);

        //Fim do Menu

        if (contador >= 1) {
            contador = 0;
            while (continua) {
                int teclaExtra = getTeclaExtra();
                if (teclaExtra == ESC && !saiu) {
                    while (getTeclaExtra() == ESC) {}
                    pausado = !pausado;
                    saindo = true;

                } else if (teclaExtra == PAUSE) {
                    while (getTeclaExtra() == PAUSE) {}
                    pausado = !pausado;

                } else if (teclaExtra == MUDAR_DE_ESTAGIO) {
                    if (estagioAtual == 1) {
                        rest(50);
                        estagioAtual = 2;
                        inicio = true;
                        rest(200);
                    } else {
                        while (getTeclaExtra() == MUDAR_DE_ESTAGIO) {}
                        pausado = !pausado;
                    }
                } else {
                    //Processa as teclas clicadas que no so Pause ou J

                    int teclaJogador1;
                    int teclaJogador2;

                    if (estagioAtual == 1 && inicio) {
                        imagensFaseAtual = new Imagens("imagens/imagensDoJogo.txt", "imagens/cenario/cenarioFase1.bmp");
                        controleFaseAtual = new Controle(singlePlayer, "imagens/colisao/mapaDeColisaoFase1.bmp", "imagens/colisao/coordenadasFase1.txt");
                        saidaFaseAtual = new Saida(imagensFaseAtual);
                        entradaFaseAtual = new Entrada();
                        inicio = false;
                        rest(30);

                    } else if (estagioAtual == 2 && inicio) {
                        imagensFaseAtual->setCenario("imagens/cenario/cenarioFase2.bmp");
                        controleFaseAtual->mudarEstagio("imagens/colisao/mapaDeColisaoFase2.bmp","imagens/colisao/coordenadasFase2.txt");
                        saidaFaseAtual->setEstagio(imagensFaseAtual);
                        inicio = false;

                    } else {
                        teclaJogador1 = entradaFaseAtual->getTeclaJogador1();
                        teclaJogador2 = entradaFaseAtual->getTeclaJogador2();
                        respostaControle = &(controleFaseAtual->rodando(saiu,pausado,singlePlayer,teclaJogador1,teclaJogador2));
						//cria os personagens e manda para a saida!
                        if (saindo) {
                            draw_sprite(bufferFinalizar, imagemFinalizar, 0, 0);
                            draw_sprite(screen, bufferFinalizar, (MAX_X - imagemFinalizar->w)/2, (MAX_Y - imagemFinalizar->h)/2);

                            bool decidiuSeVaiFinalizar = false;
                            while (!decidiuSeVaiFinalizar && !saiu) {
                                rest(40);
                                if (getTeclaExtra() == ESC) {
                                    decidiuSeVaiFinalizar = true;
                                    saiu = true;
                                    pausado = false;
                                } else {
                                    if (getTeclaExtra() == ENTER) {
                                        while (getTeclaExtra() == ENTER) {}
                                        saindo = false;
                                        pausado = false;
                                        decidiuSeVaiFinalizar = true;
                                    }
                                }
                            }
                            clear_bitmap(bufferFinalizar);
                        } else {
							saidaFaseAtual->setServidor(respostaControle);
							saidaFaseAtual->imprimirNaTela(respostaControle->respostaControle,bufferPause,imagemPause);
                        }

						if (respostaControle->respostaControle == ACABOU_FASE) {
                            if (estagioAtual == 1) {
                                estagioAtual = 2;
                                inicio = true;
                            } else {
                                clear(screen);
                                BITMAP* ganhou = load_bitmap("imagens/menu/venceu.bmp",NULL);
                                draw_sprite(screen,ganhou,0,0);
                                destroy_bitmap(ganhou);
                                _sleep(1000);
                                continua = false;
                                delete(controleFaseAtual);
                                delete(saidaFaseAtual);
                                delete(imagensFaseAtual);
                                delete(entradaFaseAtual);
                            }
						} else if (respostaControle->respostaControle == MORREU) {
                            continua = false;
                            clear(screen);
                            BITMAP* perdeu = load_bitmap("imagens/menu/gameOver.bmp",NULL);
                            draw_sprite(screen,perdeu,0,0);
                            destroy_bitmap(perdeu);
                            _sleep(1000);
                            delete(controleFaseAtual);
                            delete(saidaFaseAtual);
                            delete(imagensFaseAtual);
                            delete(entradaFaseAtual);
						} else if (respostaControle->respostaControle == SAIR) {
                            continua = false;
                            delete(controleFaseAtual);
                            delete(saidaFaseAtual);
                            delete(imagensFaseAtual);
                            delete(entradaFaseAtual);
                        }
                        rest(30);
                    }

                }
            }
        }
    }
}
